SystemOrganization addCategory: #Range!

TestCase subclass: #RangeTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

RangeTestCase subclass: #OneRangeTestCase
	instanceVariableNames: 'range'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

OneRangeTestCase subclass: #AbnormalRangeTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

!AbnormalRangeTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 17:49'!
isAbstract

	^false! !

!AbnormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:10'!
setUp

	super setUp.
	range := Range new! !

!AbnormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:11'!
testIsNormal50

	range start: 5.
	range stop: 0.
	self deny: range isNormal! !

!AbnormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:11'!
testIsNormal55CC

	range start: 5.
	range isStartOpen: false.
	range stop: 5.
	range isStopOpen: false.
	self assert: range isNormal! !

!AbnormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:11'!
testIsNormal55CO

	range start: 5.
	range isStartOpen: false.
	range stop: 5.
	range isStopOpen: true.
	self deny: range isNormal! !

!AbnormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:11'!
testIsNormal55OC

	range start: 5.
	range isStartOpen: true.
	range stop: 5.
	range isStopOpen: false.
	self deny: range isNormal! !

!AbnormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:12'!
testIsNormal55OO

	range start: 5.
	range isStartOpen: true.
	range stop: 5.
	range isStopOpen: true.
	self deny: range isNormal! !

OneRangeTestCase subclass: #NormalRangeTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

!NormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:13'!
includesStart

	^true! !

!NormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:13'!
includesStop

	^false! !

!NormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:13'!
setUp

	super setUp.
	range := Range new.
	range start: self startNumber.
	range stop: self stopNumber! !

!NormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:14'!
startNumber

	^1! !

!NormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:14'!
stopNumber

	^4! !

!NormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:14'!
testIncludesInside

	self assert: (range includes: (self startNumber + self stopNumber)/2)! !

!NormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:14'!
testIncludesLeftOutside

	self deny: (range includes: self startNumber-1)! !

!NormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:15'!
testIncludesRightOutside

	self deny: (range includes: self stopNumber + 2)! !

!NormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:16'!
testIncludesStart

	self assert: self includesStart equals: (range includes: self startNumber)! !

!NormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testIncludesStop

	self assert: self includesStop equals: (range includes: self stopNumber)! !

!NormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:15'!
testIsNormal

	self assert: range isNormal! !

!NormalRangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testMiddel

	self assert: (self startNumber + self stopNumber)/2 equals: range middle! !

NormalRangeTestCase subclass: #RangeClosedClosedTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

!RangeClosedClosedTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:18'!
isAbstract

	^false! !

!RangeClosedClosedTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:17'!
includesStart

	^true! !

!RangeClosedClosedTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:17'!
includesStop

	^true! !

!RangeClosedClosedTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:17'!
setUp

	super setUp.
	range isStartOpen: false.
	range isStopOpen: false! !

NormalRangeTestCase subclass: #RangeClosedOpenedTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

!RangeClosedOpenedTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:19'!
isAbstract

	^false! !

!RangeClosedOpenedTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:18'!
includesStart

	^true! !

!RangeClosedOpenedTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:18'!
includesStop

	^false! !

!RangeClosedOpenedTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:19'!
setUp

	super setUp.
	range isStartOpen: false.
	range isStopOpen: true! !

NormalRangeTestCase subclass: #RangeOpenedClosedTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

!RangeOpenedClosedTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:21'!
isAbstract

	^false! !

!RangeOpenedClosedTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:20'!
includesStart

	^false! !

!RangeOpenedClosedTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:20'!
includesStop

	^true! !

!RangeOpenedClosedTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:20'!
setUp

	super setUp.
	range isStartOpen: true.
	range isStopOpen: false! !

NormalRangeTestCase subclass: #RangeOpenedOpenedTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

!RangeOpenedOpenedTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:22'!
isAbstract

	^false! !

!RangeOpenedOpenedTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:22'!
includesStart

	^false! !

!RangeOpenedOpenedTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:22'!
includesStop

	^false! !

!RangeOpenedOpenedTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:22'!
setUp

	super setUp.
	range isStartOpen: true.
	range isStopOpen: true! !

!RangeTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:07'!
isAbstract

	^true! !

RangeTestCase subclass: #TwoRangesTestCase
	instanceVariableNames: 'range1 range2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

TwoRangesTestCase subclass: #CircumscriptionOfTwoRangesTestCase
	instanceVariableNames: 'cum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

CircumscriptionOfTwoRangesTestCase subclass: #CircumscriptionOfTwoSeparatedRangesTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

!CircumscriptionOfTwoSeparatedRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 1/24/2012 19:31'!
setUp

	super setUp.
	range1
		start: 2;
		stop: 5.
	range2
		start: 7;
		stop: 10.! !

!CircumscriptionOfTwoSeparatedRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 1/24/2012 19:51'!
testCloseClose

	range1 isStartOpen: false.
	range1 isStopOpen: true.
	range2 isStartOpen: true.
	range2 isStopOpen: false.
	
	cum := range1 circumscription: range2.
	self assert: 2 equals: cum start.
	self assert: 10 equals: cum stop.
	self deny: cum isStartOpen.
	self deny: cum isStopOpen.  ! !

!CircumscriptionOfTwoSeparatedRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 1/24/2012 19:51'!
testCloseOpen

	range1 isStartOpen: false.
	range1 isStopOpen: true.
	range2 isStartOpen: true.
	range2 isStopOpen: true.
	
	cum := range1 circumscription: range2.
	self assert: 2 equals: cum start.
	self assert: 10 equals: cum stop.
	self deny: cum isStartOpen.
	self assert: cum isStopOpen.  ! !

!CircumscriptionOfTwoSeparatedRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 1/24/2012 19:52'!
testOpenClose

	range1 isStartOpen: true.
	range1 isStopOpen: true.
	range2 isStartOpen: true.
	range2 isStopOpen: false.
	
	cum := range1 circumscription: range2.
	self assert: 2 equals: cum start.
	self assert: 10 equals: cum stop.
	self assert: cum isStartOpen.
	self deny: cum isStopOpen.  ! !

!CircumscriptionOfTwoSeparatedRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 1/24/2012 19:33'!
testOpenOpen

	range1 isStartOpen: true.
	range1 isStopOpen: true.
	range2 isStartOpen: true.
	range2 isStopOpen: true.
	
	cum := range1 circumscription: range2.
	self assert: 2 equals: cum start.
	self assert: 10 equals: cum stop.
	self assert: cum isStartOpen.
	self assert: cum isStopOpen.  ! !

TwoRangesTestCase subclass: #IntersectionOfTwoRangesTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

IntersectionOfTwoRangesTestCase subclass: #IntersectionOfCoveringTwoRangesTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

!IntersectionOfCoveringTwoRangesTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:29'!
isAbstract

	^false! !

!IntersectionOfCoveringTwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:28'!
setUp

	super setUp.
	range1 start: 0; stop: 7.
	range2 start: 3; stop: 5! !

!IntersectionOfCoveringTwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testCloseClose

	range2 isStopOpen: false.
	range2 isStartOpen: false.
	self assert: (Range new start: 3; stop: 5; isStartOpen: false; isStopOpen: false) equals: (range1 intersection: range2)! !

!IntersectionOfCoveringTwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:17'!
testCloseOpen

	range2 isStopOpen: false.
	range2 isStartOpen: true.
	self assert: (Range new start: 3; stop: 5; isStartOpen: true; isStopOpen: false) equals: (range1 intersection: range2)! !

!IntersectionOfCoveringTwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testOpenClose

	range2 isStopOpen: true.
	range2 isStartOpen: false.
	self assert: (Range new start: 3; stop: 5; isStartOpen: false; isStopOpen: true) equals: (range1 intersection: range2)! !

!IntersectionOfCoveringTwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testOpenOpen

	range2 isStopOpen: true.
	range2 isStartOpen: true.
	self assert: (Range new start: 3; stop: 5; isStartOpen: true; isStopOpen: true) equals: (range1 intersection: range2)! !

IntersectionOfTwoRangesTestCase subclass: #IntersectionOfOverlappingTwoRangesTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

!IntersectionOfOverlappingTwoRangesTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:31'!
isAbstract

	^false! !

!IntersectionOfOverlappingTwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:30'!
setUp

	super setUp.
	range1 start: 0; stop: 5.
	range2 start: 3; stop: 7! !

!IntersectionOfOverlappingTwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:17'!
testCloseClose

	range1 isStopOpen: false.
	range2 isStartOpen: false.
	self assert: (Range new start: 3; stop: 5; isStartOpen: false; isStopOpen: false) equals: (range1 intersection: range2)! !

!IntersectionOfOverlappingTwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testCloseOpen

	range1 isStopOpen: false.
	range2 isStartOpen: true.
	self assert: (Range new start: 3; stop: 5; isStartOpen: true; isStopOpen: false) equals: (range1 intersection: range2)! !

!IntersectionOfOverlappingTwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testOpenClose

	range1 isStopOpen: true.
	range2 isStartOpen: false.
	self assert: (Range new start: 3; stop: 5; isStartOpen: false; isStopOpen: true) equals: (range1 intersection: range2)! !

!IntersectionOfOverlappingTwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testOpenOpen

	range1 isStopOpen: true.
	range2 isStartOpen: true.
	self assert: (Range new start: 3; stop: 5; isStartOpen: true; isStopOpen: true) equals: (range1 intersection: range2)! !

IntersectionOfTwoRangesTestCase subclass: #IntersectionOfReverselyOverlappingTwoRangesTestCase2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

!IntersectionOfReverselyOverlappingTwoRangesTestCase2 classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:35'!
isAbstract

	^false! !

!IntersectionOfReverselyOverlappingTwoRangesTestCase2 methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:33'!
setUp

	super setUp.
	range1 start: 3; stop: 7.
	range2 start: 0; stop: 5! !

!IntersectionOfReverselyOverlappingTwoRangesTestCase2 methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testCloseClose

	range1 isStartOpen: false.
	range2 isStopOpen: false.
	self assert: (Range new start: 3; stop: 5; isStartOpen: false; isStopOpen: false) equals: (range1 intersection: range2)! !

!IntersectionOfReverselyOverlappingTwoRangesTestCase2 methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testCloseOpen

	range1 isStartOpen: false.
	range2 isStopOpen: true.
	self assert: (Range new start: 3; stop: 5; isStartOpen: false; isStopOpen: true) equals: (range1 intersection: range2)! !

!IntersectionOfReverselyOverlappingTwoRangesTestCase2 methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testOpenClose

	range1 isStartOpen: true.
	range2 isStopOpen: false.
	self assert: (Range new start: 3; stop: 5; isStartOpen: true; isStopOpen: false) equals: (range1 intersection: range2)! !

!IntersectionOfReverselyOverlappingTwoRangesTestCase2 methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testOpenOpen

	range1 isStartOpen: true.
	range2 isStopOpen: true.
	self assert: (Range new start: 3; stop: 5; isStartOpen: true; isStopOpen: true) equals: (range1 intersection: range2)! !

IntersectionOfTwoRangesTestCase subclass: #IntersectionOfSeparatedTwoRangesTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

!IntersectionOfSeparatedTwoRangesTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:37'!
isAbstract

	^false! !

!IntersectionOfSeparatedTwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:36'!
setUp

	super setUp.
	range1 start: 5; stop: 7.
	range2 start: 0; stop: 3! !

!IntersectionOfSeparatedTwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testCloseClose

	range1 isStartOpen: false.
	range2 isStopOpen: false.
	self assert: nil equals: (range1 intersection: range2)! !

!IntersectionOfSeparatedTwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testCloseOpen

	range1 isStartOpen: false.
	range2 isStopOpen: true.
	self assert: nil equals: (range1 intersection: range2)! !

!IntersectionOfSeparatedTwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testOpenClose

	range1 isStartOpen: true.
	range2 isStopOpen: false.
	self assert: nil equals: (range1 intersection: range2)! !

!IntersectionOfSeparatedTwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2011 13:18'!
testOpenOpen

	range1 isStartOpen: true.
	range2 isStopOpen: true.
	self assert: nil equals: (range1 intersection: range2)! !

TwoRangesTestCase subclass: #TwoRangesCoversStartSideTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

!TwoRangesCoversStartSideTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:25'!
isAbstract

	^false! !

!TwoRangesCoversStartSideTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:23'!
setUp

	super setUp.
	range1 start: 1; stop: 4.
	range2 start: 1; stop: 3! !

!TwoRangesCoversStartSideTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:24'!
testCloseClose

	range1 isStartOpen: false.
	range2 isStartOpen: false.
	self assert: (range1 covers: range2)! !

!TwoRangesCoversStartSideTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:24'!
testCloseOpen

	range1 isStartOpen: false.
	range2 isStartOpen: true.
	self assert: (range1 covers: range2)! !

!TwoRangesCoversStartSideTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:24'!
testOpenClose

	range1 isStartOpen: true.
	range2 isStartOpen: false.
	self deny: (range1 covers: range2)! !

!TwoRangesCoversStartSideTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:24'!
testOpenOpen

	range1 isStartOpen: true.
	range2 isStartOpen: true.
	self assert: (range1 covers: range2)! !

TwoRangesTestCase subclass: #TwoRangesCoversStopSideTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

!TwoRangesCoversStopSideTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:27'!
isAbstract

	^false! !

!TwoRangesCoversStopSideTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:25'!
setUp

	super setUp.
	range1 start: 1; stop: 4.
	range2 start: 2; stop: 4! !

!TwoRangesCoversStopSideTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:26'!
testCloseClose

	range1 isStopOpen: false.
	range2 isStopOpen: false.
	self assert: (range1 covers: range2)! !

!TwoRangesCoversStopSideTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:26'!
testCloseOpen

	range1 isStopOpen: false.
	range2 isStopOpen: true.
	self assert: (range1 covers: range2)! !

!TwoRangesCoversStopSideTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:26'!
testOpenClose

	range1 isStopOpen: true.
	range2 isStopOpen: false.
	self deny: (range1 covers: range2)! !

!TwoRangesCoversStopSideTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:26'!
testOpenOpen

	range1 isStopOpen: true.
	range2 isStopOpen: true.
	self assert: (range1 covers: range2)! !

!TwoRangesTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:09'!
setUp

	super setUp.
	range1 := Range new.
	range2 := Range new! !

!SequenceableCollection methodsFor: '*Range' stamp: 'hjo 3/17/2008 13:53'!
sliceRanges: monoBlock

	|ranges |
	ranges := OrderedCollection new.
	(self asArray collect: monoBlock), (Array with: false)
		keysAndValuesDo:[:index :each|
			(ranges isEmpty not and: [ranges last stop isNil ])
				ifTrue: [ each ifFalse: [ranges last stop: index-1]]
				ifFalse: [ each ifTrue: [ranges add: (Range closed start: index; yourself)]]
		].
	^ranges! !

Object subclass: #Range
	instanceVariableNames: 'start stop isStartOpen isStopOpen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Range'!

!Range classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:04'!
close: number1 close: number2

	^self new
		start: number1;
		stop: number2;
		isStartOpen: false;
		isStopOpen: false! !

!Range classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:04'!
close: number1 open: number2

	^self new
		start: number1;
		stop: number2;
		isStartOpen: false;
		isStopOpen: true! !

!Range classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:04'!
closed

	^self new isStartOpen: false; isStopOpen: false! !

!Range classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:05'!
closedSpot: aNumber

	^self close: aNumber close: aNumber! !

!Range classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:05'!
open: number1 close: number2

	^self new
		start: number1;
		stop: number2;
		isStartOpen: true;
		isStopOpen: false! !

!Range classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:05'!
open: number1 open: number2

	^self new
		start: number1;
		stop: number2;
		isStartOpen: true;
		isStopOpen: true! !

!Range classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 14:06'!
opened

	^self new isStartOpen: true; isStopOpen: true! !

!Range methodsFor: 'comparing' stamp: 'hjo 3/17/2008 13:55'!
= aRange

	^
	(OrderedCollection new
		add: [ self start = aRange start ];
		add: [ self stop = aRange stop ];
		add: [ self isStartOpen = aRange isStartOpen ];
		add: [ self isStopOpen = aRange isStopOpen ];
		yourself) allSatisfy: [:condition| condition value ]! !

!Range methodsFor: 'computation results' stamp: 'hjo 1/24/2012 20:01'!
circumscription: aRange 

	| cum block |
	cum := self species new
		start: (start min: aRange start);
		stop: (stop max: aRange stop);
		yourself.
	
	block := [ :numGetter :openGetter :openSetter |
		| cumValue aRangeValue selfIsOpen aRangeIsOpen |
		cumValue := cum perform: numGetter.
		aRangeValue := aRange perform: numGetter.
		selfIsOpen := self perform: openGetter.
		aRangeIsOpen := aRange perform: openGetter.
		cum perform: openSetter with: (
			cumValue = (self perform: numGetter)  
				ifTrue: [
					cumValue = aRangeValue
						ifTrue: [selfIsOpen and: [aRangeIsOpen]]
						ifFalse: [selfIsOpen]
					]
				ifFalse: [
					cumValue = aRangeValue
						ifTrue: [aRangeIsOpen]
						ifFalse: [self error: 'There is something wrong here.']
					]).		
		].
	block value: #start value: #isStartOpen value: #isStartOpen: .
	block value: #stop value: #isStopOpen value: #isStopOpen: .
	^cum! !

!Range methodsFor: 'computation results' stamp: 'hjo 3/17/2008 13:55'!
covers: aRange 

	"|block|
	block := [:end1 :end2 :open1 :open2 | 
		end1 = end2 and: [(open1 and: [open2 not]) not]]."
	^(self start < aRange start or: [self start = aRange start and: [(self isStartOpen and: [aRange isStartOpen not]) not]])
	and:
	[aRange stop < self stop or: [aRange stop = self stop and: [(self isStopOpen and: [aRange isStopOpen not]) not]]]! !

!Range methodsFor: 'testing' stamp: 'hjo 3/17/2008 13:56'!
hash

	^(self start hash * 7 + self stop hash) hash! !

!Range methodsFor: 'testing' stamp: 'hjo 3/17/2008 13:57'!
includes: aNumber

	| comparisonBlock |
	comparisonBlock := 
		[:isOpen :left :right |
			isOpen 
				ifTrue: [ left < right ]
				ifFalse: [ left <= right ]
		].
	^(comparisonBlock value: self isStartOpen value: self start value: aNumber)
		and:
	[comparisonBlock value: self isStopOpen value: aNumber value: self stop]! !

!Range methodsFor: 'enumerating' stamp: 'HwaJong 10/13/2012 02:34'!
intersection: aRange

	| ranges |
	(self covers: aRange) ifTrue: [ ^aRange copy ].
	(aRange covers: self) ifTrue: [ ^self copy ].

	(ranges := SortedCollection sortBlock: (UnarySortDescriptor ascendingBy: #span))
		add: 
			(self class new 
				start: aRange start; 
				stop: self stop; 
				isStartOpen: aRange isStartOpen; 
				isStopOpen: self isStopOpen);
		add:
			(self class new 
				start: self start; 
				stop: aRange stop;
				isStartOpen: self isStartOpen;
				isStopOpen: aRange isStopOpen).
	^ranges first isNormal
		ifTrue: [ ranges first ]
		ifFalse: [ nil ]! !

!Range methodsFor: 'testing' stamp: 'hjo 3/17/2008 13:58'!
isNormal

	^self stop > self start or: [self stop = self start and: [ (self isStartOpen or: [self isStopOpen ]) not ] ]! !

!Range methodsFor: 'testing' stamp: 'hjo 3/17/2008 13:59'!
isStartOpen

	isStartOpen isNil ifTrue: [ self isStartOpen: false ].
	^isStartOpen! !

!Range methodsFor: 'accessing' stamp: 'hjo 3/17/2008 13:59'!
isStartOpen: aBoolean

	isStartOpen := aBoolean! !

!Range methodsFor: 'testing' stamp: 'hjo 3/17/2008 13:59'!
isStopOpen

	isStopOpen isNil ifTrue: [ self isStopOpen: true ].
	^isStopOpen! !

!Range methodsFor: 'accessing' stamp: 'hjo 3/17/2008 14:00'!
isStopOpen: aBoolean

	isStopOpen := aBoolean! !

!Range methodsFor: 'accessing' stamp: 'hjo 3/17/2008 14:00'!
middle

	^(self start + self stop)/2! !

!Range methodsFor: 'printing' stamp: 'hjo 3/17/2008 14:00'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: (self isStartOpen ifTrue: [ $( ] ifFalse: [ $[ ]).
	aStream print: self start.
	aStream nextPutAll: ' , '.
	aStream print: self stop.
	aStream nextPut: (self isStopOpen ifTrue: [ $) ] ifFalse: [ $] ]).! !

!Range methodsFor: 'computation results' stamp: 'hjo 3/17/2008 14:00'!
saturate: aNumber

	^(aNumber max: self start) min: self stop! !

!Range methodsFor: 'computation results' stamp: 'hjo 3/17/2008 14:01'!
shiftedBy: aNumber

	^self copy
		start: self start + aNumber;
		stop: self stop + aNumber! !

!Range methodsFor: 'computation results' stamp: 'hjo 3/17/2008 14:02'!
shrinkedBy: aFloat 

	| x |
	x := self span * aFloat / 2.
	^self copy 
		start: self start + x; 
		stop: self stop - x! !

!Range methodsFor: 'computation results' stamp: 'hjo 3/17/2008 14:02'!
span

	^self stop - self start! !

!Range methodsFor: 'accessing' stamp: 'hjo 3/17/2008 14:02'!
start

	^start! !

!Range methodsFor: 'accessing' stamp: 'hjo 3/17/2008 14:03'!
start: aNumber

	start := aNumber! !

!Range methodsFor: 'accessing' stamp: 'hjo 3/17/2008 14:03'!
startAndStop

	^Array with: self start with: self stop! !

!Range methodsFor: 'accessing' stamp: 'hjo 3/17/2008 14:03'!
stop

	^stop! !

!Range methodsFor: 'accessing' stamp: 'hjo 3/17/2008 14:03'!
stop: aNumber

	stop := aNumber! !
